diff mbox

[3/3] xfstests/btrfs: add stress test for btrfs quota operations

Message ID 1392261539-28903-3-git-send-email-wangsl.fnst@cn.fujitsu.com (mailing list archive)
State Not Applicable
Headers show

Commit Message

Wang Shilong Feb. 13, 2014, 3:18 a.m. UTC
So this is a stress test for btrfs quota operations. it can also
detect the following commit fixed problem:

4082bd3d73(Btrfs: fix oops when writting dirty qgroups to disk)

Signed-off-by: Wang Shilong <wangsl.fnst@cn.fujitsu.com>
---
 tests/btrfs/040     | 75 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/040.out |  2 ++
 tests/btrfs/group   |  1 +
 3 files changed, 78 insertions(+)
 create mode 100644 tests/btrfs/040
 create mode 100644 tests/btrfs/040.out
diff mbox

Patch

diff --git a/tests/btrfs/040 b/tests/btrfs/040
new file mode 100644
index 0000000..d991304
--- /dev/null
+++ b/tests/btrfs/040
@@ -0,0 +1,75 @@ 
+#! /bin/bash
+# FS QA Test No. 040
+#
+# stresstest for btrfs quota operations. we run fsstress and quota
+# operations concurrently.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2014 Fujitsu.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+rm -f $seqres.full
+
+_quota_enabled_background()
+{
+	i=1
+	while [ $i -le 5 ]
+	do
+		run_check $BTRFS_UTIL_PROG quota enable $SCRATCH_MNT
+		run_check $BTRFS_UTIL_PROG quota disable $SCRATCH_MNT
+		i=$(($i+1))
+		sleep 1
+	done
+}
+
+MKFS_SIZE=$((2 * 1024 * 1024 * 1024))
+run_check _scratch_mkfs_sized $MKFS_SIZE
+run_check _scratch_mount
+
+_quota_enabled_background &
+run_check $FSSTRESS_PROG -d $SCRATCH_MNT -w -p 5 -n 1000 \
+	$FSSTRESS_AVOID
+
+run_check _scratch_unmount
+_check_scratch_fs
+
+# success, all done
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/btrfs/040.out b/tests/btrfs/040.out
new file mode 100644
index 0000000..9e3d4d9
--- /dev/null
+++ b/tests/btrfs/040.out
@@ -0,0 +1,2 @@ 
+QA output created by 040
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index ba6b70c..3dc82e5 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -39,3 +39,4 @@ 
 034 auto quick
 038 auto quick
 039 auto quick
+040 auto quick